## eztrace 2.2.1

=== src/instrumentation/CMakeLists.txt ===
set(EZTRACE_BINARY_INSTRUMENTATION_SOURCES
  binary.h
  errors.c
  include/eztrace-instrumentation/errors.h
  include/eztrace-instrumentation/linux.h
  include/eztrace-instrumentation/pptrace.h
  pptrace.c
  proc_maps.c
  proc_maps.h
  include/eztrace-instrumentation/tracing.h
  tracing.c
)

SET(COMPILE_FLAGS "")

if(ENABLE_BIN_INSTRUMENTATION)

  list(APPEND EZTRACE_BINARY_INSTRUMENTATION_SOURCES
    binary_instrumentation/bfd.c
    binary_instrumentation/binary.c
    binary_instrumentation/hijack.c
    binary_instrumentation/hijack.h
    binary_instrumentation/isize.h
    binary_instrumentation/memory.c
    binary_instrumentation/memory.h
    binary_instrumentation/opcodes.h
  )

if(CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "x86_64")
  list(APPEND EZTRACE_BINARY_INSTRUMENTATION_SOURCES
    binary_instrumentation/arch/x86_64/hijack.c
    binary_instrumentation/arch/x86_64/intel.c)

  if(LIBOPCODES_FOUND)
    list(APPEND EZTRACE_BINARY_INSTRUMENTATION_SOURCES
      binary_instrumentation/arch/x86_64/opcode.c)
  else()
    list(APPEND EZTRACE_BINARY_INSTRUMENTATION_SOURCES
      binary_instrumentation/arch/x86_64/trace.c)
  endif()

  string(APPEND COMPILE_FLAGS -DHAVE_CHECK_INSTRUCTIONS)

endif()

if(CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "arm")
  list(APPEND EZTRACE_BINARY_INSTRUMENTATION_SOURCES
    binary_instrumentation/arch/armv7/arm.c
    binary_instrumentation/arch/armv7/opcode.c
    binary_instrumentation/arch/armv7/trace.c)
endif()

  set(EZTRACE_BINARY_INSTRUMENTATION_DEPS
    PRIVATE
      bfd
      opcodes
  )
endif()

add_library(eztrace-instrumentation SHARED ${EZTRACE_BINARY_INSTRUMENTATION_SOURCES})

target_include_directories(eztrace-instrumentation
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDE_DIR}>
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/binary_instrumentation
    ${CMAKE_CURRENT_SOURCE_DIR}
)

target_compile_options(eztrace-instrumentation
  PUBLIC
    ${EZTRACE_BINARY_INSTRUMENTATION_FLAG}
  PRIVATE
    # -Werror # TODO
    ${COMPILE_FLAGS}
)

target_link_libraries(eztrace-instrumentation
    ${EZTRACE_BINARY_INSTRUMENTATION_DEPS}
  PUBLIC
    eztrace-core
)

if (ENABLE_BIN_INSTRUMENTATION)
  target_link_libraries(eztrace-instrumentation
    PRIVATE
  )
endif()


install(TARGETS eztrace-instrumentation EXPORT EZTraceInstrumentationTargets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/eztrace-instrumentation DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== src/modules/CMakeLists.txt ===
# Default modules
if(EZTRACE_ENABLE_MEMORY)
  add_subdirectory(memory)
endif()

if(EZTRACE_ENABLE_POSIXIO)
  add_subdirectory(posixio)
endif()

if(EZTRACE_ENABLE_PTHREAD)
  add_subdirectory(pthread)
endif()

# Optional modules
if (EZTRACE_ENABLE_MPI)
  add_subdirectory(mpi)
endif ()

if (EZTRACE_ENABLE_OPENMP)
  add_subdirectory(omp)
endif()

if (EZTRACE_ENABLE_CUDA)
  add_subdirectory(cuda)
endif ()

if (EZTRACE_ENABLE_STARPU)
  add_subdirectory(starpu)
endif()
if (EZTRACE_ENABLE_STARPU_API)
  add_subdirectory(starpu_api)
endif ()

if (EZTRACE_ENABLE_OMPT)
  add_subdirectory(ompt)
endif()

if (EZTRACE_ENABLE_KOKKOS)
  add_subdirectory(kokkos)
endif()

if(EZTRACE_ENABLE_IOTRACER)
  add_subdirectory(iotracer)
endif()

if(EZTRACE_ENABLE_PNETCDF)
  add_subdirectory(pnetcdf)
endif()

if(EZTRACE_ENABLE_NETCDF)
  add_subdirectory(netcdf)
endif()

if(EZTRACE_ENABLE_PYTHON)
  add_subdirectory(python)
endif()

if(EZTRACE_ENABLE_COMPILER_INSTRUMENTATION)
  add_subdirectory(compiler_instrumentation)
endif()

# Some modules have not been ported to OTF2 yet

#if (EZTRACE_ENABLE_PAPI)
#  add_subdirectory(papi)
#endif ()

=== test/python/Makefile ===
CFLAGS=
LDFLAGS=

BIN=

all: $(BIN)

%: %.c
	$(CC) -o $@ $^ $(CFLAGS) $(LDFLAGS)

test: $(BIN)
	./run.sh
clean:
	rm -f $(BIN)

=== test/unit_tests/CMakeLists.txt ===
enable_testing()

add_executable(htable
  htable.c)

# depending on the framework, you need to link to it
target_link_libraries(htable
  eztrace-core)

target_compile_options(htable
  PRIVATE
    -Wall -Wextra -Wpedantic
    -Werror
)

target_include_directories(htable
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/src/core/include/eztrace-core/
)

add_test(NAME htable COMMAND htable)
set(EZTRACE_LIBRARY_PATH "${CMAKE_BINARY_DIR}/src/eztrace-lib")

# Get the list of tests, and set environment variables
get_property(test_list DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY TESTS)
set_property(TEST ${test_list}
  PROPERTY ENVIRONMENT
  "EZTRACE_LIBRARY_PATH=${EZTRACE_LIBRARY_PATH}"
  ${TEST_ENVIRONMENT}
)

=== src/modules/kokkos/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.19)
include(CheckSourceCompiles)

PROJECT(eztrace-kokkos CXX)

find_package (Kokkos REQUIRED)

add_library(eztrace-kokkos SHARED
  kokkos.cpp
)

target_link_libraries(eztrace-kokkos
  PRIVATE
    atomic
    dl
    eztrace-core
    eztrace-lib
    eztrace-instrumentation
    Kokkos::kokkos
   )

target_include_directories(eztrace-kokkos
  PRIVATE
  ${CMAKE_SOURCE_DIR}/src/core/include/eztrace-core/
  Kokkos::kokkos
)

set_target_properties(eztrace-kokkos PROPERTIES LINKER_LANGUAGE CXX)

#---------------------------------------------

install(TARGETS eztrace-kokkos
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

=== src/modules/omp/CMakeLists.txt ===

add_library(eztpomp SHARED
  pomp-lib-dummy/pomp2_fwrapper.c
  pomp-lib-dummy/pomp2_fwrapper_base.c
  pomp-lib-dummy/pomp2_fwrapper_base.h
  pomp-lib-dummy/pomp2_lib.c
  pomp-lib-dummy/pomp2_lib.h
  pomp-lib-dummy/pomp2_region_info.c
  pomp-lib-dummy/pomp2_region_info.h
)

target_include_directories(eztpomp
  PUBLIC
    pomp-lib-dummy
)

target_compile_options(eztpomp
  PRIVATE
    -Wall -Wextra
    -DOPENMP_FOUND
    ${OpenMP_C_FLAGS}
    )

target_link_libraries(eztpomp
  PRIVATE
    eztrace-core
)

target_compile_options(eztpomp
  PRIVATE
    -Wall -Wextra
    -DOPENMP_FOUND
    ${OpenMP_C_FLAGS}
)

#---------------------------------------------

# Create : libeztrace-omp.so

add_library(eztrace-openmp SHARED
  gomp.c
)

target_link_libraries(eztrace-openmp
  PRIVATE
    atomic
    dl
    eztrace-core
    eztrace-instrumentation
    eztrace-lib
    gomp
)

target_compile_options(eztrace-openmp
  PRIVATE
    -Wall -Wextra
    -DOPENMP_FOUND
    ${OpenMP_C_FLAGS}
    -Wno-gnu-zero-variadic-macro-arguments
)


set(EZTRACE_CC_PATH ${CMAKE_CURRENT_BINARY_DIR}/bin/eztrace_cc)
configure_file (eztrace_cc.in ${EZTRACE_CC_PATH} @ONLY)

install(TARGETS eztpomp  eztrace-openmp
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(PROGRAMS ${EZTRACE_CC_PATH} DESTINATION ${CMAKE_INSTALL_BINDIR})

=== test/pptrace/comparison/Makefile ===
# Copyright (C) CNRS, INRIA, Université Bordeaux 1, Télécom SudParis
# See COPYING in top-level directory.

DIRS=programs/md programs/simple

all:	recursive-all

run:	all recursive-run

clean:	recursive-clean
	rm -f $(BINARY)
	
recursive-%:
	@for i in $(DIRS); do \
		make -C $$i $(subst recursive-,,$@); \
	done;

=== test/pptrace/automatic/testcase/Makefile ===
# Copyright (C) CNRS, INRIA, Université Bordeaux 1, Télécom SudParis
# See COPYING in top-level directory.

TESTCASES_=$(patsubst %.c,%,$(wildcard *.c))
ifeq "32" "$(shell getconf LONG_BIT)"
	BITS=32
else
	BITS=32 64
endif
TESTCASES=$(foreach testcase,$(TESTCASES_),$(foreach b,$(BITS),$(testcase).$(b) $(testcase).$(b).so))

all:	$(TESTCASES)

echo:
	echo '$(BITS) + $(TESTCASES_) = $(TESTCASES)'
	
%.32:	%.c
	@$(CC) -m32 -o $@ $^

%.64:	%.c
	@$(CC) -m64 -o $@ $^

%.32.so:	%.c
	@$(CC) -m32 -shared -fPIC -Wl,-Bsymbolic -o $@ $^

%.64.so:	%.c
	@$(CC) -m64 -shared -fPIC -Wl,-Bsymbolic -o $@ $^

clean:
	@rm -f $(TESTCASES)

=== test/pptrace/comparison/instrument/pin/Makefile ===
# Copyright (C) CNRS, INRIA, Université Bordeaux 1, Télécom SudParis
# See COPYING in top-level directory.

BINARIES=my_pin.so my_pin_dummy.so

LIBINSTRUMENT_SIMPLE_ROOT=$(realpath ../libinstrument-dummy)
LIBINSTRUMENT_ROOT=$(realpath ../libinstrument-real)

PIN_ROOT=$(shell printenv PIN_ROOT)
LIBDWARF_DIR=$(shell printenv DWARF_LIBDIR)

PIN_CFLAGS=-DTARGET_IA32E -DFUND_TC_HOSTCPU=FUND_CPU_INTEL64 -DFUND_TC_TARGETCPU=FUND_CPU_INTEL64 -DTARGET_LINUX -DFUND_TC_HOSTOS=FUND_OS_LINUX -DFUND_TC_TARGETOS=FUND_OS_LINUX \
	-fpermissive \
	-I$(PIN_ROOT)/source/InstLib -I$(PIN_ROOT)/extras/xed2-intel64/include -I$(PIN_ROOT)/extras/components/include -I$(PIN_ROOT)/source/include -I$(PIN_ROOT)/source/include/gen
LIBINSTRUMENT_CFLAGS=-I$(LIBINSTRUMENT_ROOT)
LIBINSTRUMENT_DUMMY_CFLAGS=-I$(LIBINSTRUMENT_SIMPLE_ROOT)

PIN_LDFLAGS=-Wl,--version-script=$(PIN_ROOT)/source/include/pintool.ver -L../Lib/ -L../ExtLib/ -L$(PIN_ROOT)/extras/xed2-intel64/lib -L$(PIN_ROOT)/intel64/lib -L$(PIN_ROOT)/intel64/lib-ext \
-Wl,--rpath,$(PIN_ROOT)/extras/xed2-intel64/lib/ -L$(PIN_ROOT)/extras/xed2-intel64/lib/\
 -lpin -lxed -lelf -ldl -Wl,--rpath,$(LIBDWARF_DIR) -L$(LIBDWARF_DIR) -ldwarf

LIBINSTRUMENT_LDFLAGS=-Wl,--rpath,$(LIBINSTRUMENT_ROOT) -L$(LIBINSTRUMENT_ROOT) -linstrument
LIBINSTRUMENT_DUMMY_LDFLAGS=-Wl,--rpath,$(LIBINSTRUMENT_SIMPLE_ROOT) -L$(LIBINSTRUMENT_SIMPLE_ROOT) -linstrument

all: $(BINARIES)

my_pin.so: my_pin.cpp
	g++ -shared -o my_pin.so -fPIC my_pin.cpp $(PIN_CFLAGS) $(PIN_LDFLAGS) $(LIBINSTRUMENT_CFLAGS) $(LIBINSTRUMENT_LDFLAGS)

my_pin_dummy.so: my_pin.cpp
	g++ -shared -o my_pin_dummy.so -fPIC my_pin.cpp $(PIN_CFLAGS) $(PIN_LDFLAGS) $(LIBINSTRUMENT_DUMMY_CFLAGS) $(LIBINSTRUMENT_DUMMY_LDFLAGS)

run:
	@for i in $(TARGETS); do \
		echo ================================================================================; \
		echo Running PIN on `basename $$i` for simple instrumentation; \
		echo ================================================================================; \
		echo; \
		$(PIN_ROOT)/pin -t my_pin_dummy.so -- $$i; \
		echo ================================================================================; \
		echo Running PIN on `basename $$i` for real instrumentation; \
		echo ================================================================================; \
		echo; \
		$(PIN_ROOT)/pin -t my_pin.so -- $$i; \
	done

clean:
	rm -f *.o $(BINARIES)

=== debian/changelog ===
eztrace (2.2.1-5) unstable; urgency=medium

  * control, rules: Disable kokkos for now.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 02 Sep 2025 21:14:01 +0200

eztrace (2.2.1-4) unstable; urgency=medium

  * tests/control: Add MPI smoke test.
  * patches/mpi_core: Fix mpich/openmpi MPI build conflict.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 28 Aug 2025 12:07:25 +0200

eztrace (2.2.1-3) unstable; urgency=medium

  * control: Disable libpnetcdf-dev build-dependency on 32bit archs instead of
    enabling it on 64bit archs.
  * rules: Disable pnetcdf on 32bit archs instead of enabling it on an explicit
    list.
  * rules: Disable kokkos on archs where it fails to build.

 -- Samuel Thibault <sthibault@debian.org>  Sat, 16 Aug 2025 09:45:48 +0200

eztrace (2.2.1-2) unstable; urgency=medium

  * control: Avoid build-depending on kokkos where it failed to build.
  * patches/starpu-hip: Fix building against starpu with hip support.

 -- Samuel Thibault <sthibault@debian.org>  Sat, 16 Aug 2025 01:07:02 +0200

eztrace (2.2.1-1) unstable; urgency=medium

  * New upstream Release.
    - control: Bump cmake build-dep version accordingly.
    - control: Build-Depend on libkokkos-dev, python3, libpython3-dev.
    - control: Make eztrace depend on python3.
    - eztrace.lintian-overrides: Suppress lintian warning.
    - patches/kokkos_openmp: Fix OpenMP detection for kokkos.
    - patches/eztrace.py: Fix running python tests.
    - patches/fortran-no-mpi: Fix build with fortran but no mpi.
    - patches/mpi_mode: Fix running mpi tests.
    - patches/eztrace.py.version: Ensure to run with python3.
    - patches/CXXFLAGS: Fix taking CXXFLAGS into account.
    - patches/otf2: Fix detecting newer otf2 release.
    - rules: Enable kokkos and python backends.
    - rules: Drop cleaning source, bug #64 fixed upstream.
    - libeztrace0.lintian-overrides: Update.
  * copyright: Update.
  * Update standards version to 4.6.2, no changes needed.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 14 Aug 2025 23:10:04 +0200

eztrace (2.1.1-6) unstable; urgency=medium

  * rules: Make smoketest failure abort immediately, and add comment.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 29 Apr 2025 15:44:45 +0200

=== debian/control ===
Source: eztrace
Section: devel
Priority: optional
Maintainer: Samuel Thibault <sthibault@debian.org>
Build-Depends: debhelper-compat (= 12),
 pkgconf,
 cmake (>= 3.10),
 bc, gawk,
 gfortran,
 libiberty-dev, binutils-dev (>= 2.29~), zlib1g-dev,
 libotf2-trace-dev, otf2-tools,
 opari2, libpomp2-dev,
 clang [amd64 arm64 ppc64el riscv64 loong64], libomp-dev [amd64 arm64 ppc64el riscv64 loong64],
 libstarpu-dev (>= 1.3~), libstarpu-dev (>= 1.4.1+dfsg-7) | libstarpu-dev (<< 1.4~),
#libkokkos-dev [!armel !hppa !hurd-any !m68k !powerpc !sh4],
 libnetcdf-dev, libpnetcdf-dev [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32],
 libpapi-dev [amd64 arm64 armel armhf i386 powerpc ppc64el mips64el ppc64 x32],
 libmpich-dev, mpi-default-dev, mpi-default-bin,
 python3, libpython3-dev,
Rules-Requires-Root: no
Build-Conflicts: libeztrace0
Standards-Version: 4.6.2
Homepage: https://eztrace.gitlab.io/eztrace/
Vcs-Git: https://salsa.debian.org/debian/eztrace.git
Vcs-Browser: https://salsa.debian.org/debian/eztrace

Package: eztrace
Architecture: any
Multi-Arch: foreign
Depends: python3, ${shlibs:Depends}, ${perl:Depends}, ${misc:Depends}, libeztrace0 (= ${binary:Version}), opari2
Description: Automatic execution trace generation for HPC - tools
 EZTrace is a tool that aims at generating automatically execution traces
 from HPC (High Performance Computing) programs. It generates execution
 trace files that can be interpreted by visualization tools such as
 ViTE. It uses LD_PRELOAD and dlsym() to intercept calls to the usual HPC
 primitives, to be observed.
 .
 This package contains the tools.

Package: libeztrace-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libeztrace0 (= ${binary:Version}), ${misc:Depends}
Description: Automatic execution trace generation for HPC - development files
 EZTrace is a tool that aims at generating automatically execution traces
 from HPC (High Performance Computing) programs. It generates execution
 trace files that can be interpreted by visualization tools such as
 ViTE. It uses LD_PRELOAD and dlsym() to intercept calls to the usual HPC
 primitives, to be observed.
 .
 This package contains the development files.

Package: libeztrace0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libeztrace-dev (<< 2.0-1)
Replaces: libeztrace-dev (<< 2.0-1)
Pre-Depends: ${misc:Pre-Depends}
Description: Automatic execution trace generation for HPC - runtime libraries
 EZTrace is a tool that aims at generating automatically execution traces
 from HPC (High Performance Computing) programs. It generates execution
 trace files that can be interpreted by visualization tools such as
 ViTE. It uses LD_PRELOAD and dlsym() to intercept calls to the usual HPC
 primitives, to be observed.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk
include /usr/share/mpi-default-dev/debian_defaults

FAILED=debian/failed

ifeq ($(ARCH_DEFAULT_MPI_IMPL),openmpi)
OPENMPI=yes
else
OPENMPI=no
endif

OMPT_ARCHS = amd64 arm64 ppc64el riscv64 loong64

CONFIGURE_ENV=
CONFIGURE=-DCMAKE_INSTALL_INCLUDEDIR=/usr/include/$(DEB_HOST_MULTIARCH)

ifeq (32,$(DEB_HOST_ARCH_BITS))
CONFIGURE+=-DEZTRACE_ENABLE_PNETCDF=OFF
endif

#ifneq (,$(filter $(DEB_HOST_ARCH),armel hppa hurd-amd64 hurd-i386 m68k powerpc sh4))
CONFIGURE+=-DEZTRACE_ENABLE_KOKKOS=OFF
#endif

%:
	dh $@

# TODO: with starpu >= 1.5, EZTRACE_ENABLE_STARPU_API
override_dh_auto_configure:
	$(CONFIGURE_ENV) dh_auto_configure -Bbuild-mpich -- \
		-DEZTRACE_ENABLE_MPI=ON \
		-DEZTRACE_ENABLE_STARPU=ON \
		-DEZTRACE_ENABLE_OPENMP=ON \
		-DEZTRACE_ENABLE_POSIXIO=ON \
		-DEZTRACE_ENABLE_PTHREAD=ON \
		-DEZTRACE_ENABLE_MEMORY=ON \
		-DEZTRACE_ENABLE_OMPT=OFF \
		-DEZTRACE_ENABLE_KOKKOS=ON \
		-DEZTRACE_ENABLE_PNETCDF=ON \
		-DEZTRACE_ENABLE_NETCDF=ON \
		-DEZTRACE_ENABLE_IOTRACER=OFF \
		-DEZTRACE_ENABLE_PYTHON=ON \
		$(CONFIGURE) \
		-DMPICC=/usr/bin/mpicc.mpich -DMPIF90=/usr/bin/mpif90.mpich -DMPI_MODULE_NAME=mpich
ifeq ($(OPENMPI),yes)
	$(CONFIGURE_ENV) dh_auto_configure -Bbuild-openmpi -- \
		-DEZTRACE_ENABLE_MPI=ON \
		-DEZTRACE_ENABLE_STARPU=OFF \
		-DEZTRACE_ENABLE_OPENMP=OFF \
		-DEZTRACE_ENABLE_POSIXIO=OFF \
		-DEZTRACE_ENABLE_PTHREAD=OFF \
		-DEZTRACE_ENABLE_MEMORY=OFF \
		-DEZTRACE_ENABLE_OMPT=OFF \
		-DEZTRACE_ENABLE_KOKKOS=OFF \
		-DEZTRACE_ENABLE_PNETCDF=OFF \
		-DEZTRACE_ENABLE_NETCDF=OFF \
		-DEZTRACE_ENABLE_IOTRACER=OFF \
		-DEZTRACE_ENABLE_PYTHON=OFF \
		$(CONFIGURE) \
		-DMPICC=/usr/bin/mpicc.openmpi -DMPIF90=/usr/bin/mpif90.openmpi -DMPI_MODULE_NAME=openmpi
endif
ifneq ($(filter $(DEB_HOST_ARCH),$(OMPT_ARCHS)),)
	$(CONFIGURE_ENV) CC=clang dh_auto_configure -Bbuild-ompt -- \
		-DEZTRACE_ENABLE_MPI=OFF \
		-DEZTRACE_ENABLE_STARPU=OFF \
		-DEZTRACE_ENABLE_OPENMP=OFF \
		-DEZTRACE_ENABLE_POSIXIO=OFF \
		-DEZTRACE_ENABLE_PTHREAD=OFF \
		-DEZTRACE_ENABLE_MEMORY=OFF \
		-DEZTRACE_ENABLE_OMPT=ON \
		-DEZTRACE_ENABLE_KOKKOS=OFF \
		-DEZTRACE_ENABLE_PNETCDF=OFF \
		-DEZTRACE_ENABLE_NETCDF=OFF \
		-DEZTRACE_ENABLE_IOTRACER=OFF \
		-DEZTRACE_ENABLE_PYTHON=OFF \
		$(CONFIGURE)
endif

override_dh_auto_build:
	@echo 'blhc: ignore-line-regexp: \[\ *[0-9]+%\]\ Building\ C\ object\ (src|test)/.+\.c\.o'
	dh_auto_build -Bbuild-mpich
ifeq ($(OPENMPI),yes)
	dh_auto_build -Bbuild-openmpi
endif
ifneq ($(filter $(DEB_HOST_ARCH),$(OMPT_ARCHS)),)
	dh_auto_build -Bbuild-ompt
endif

override_dh_auto_clean:
	dh_auto_clean -Bbuild-mpich
ifeq ($(OPENMPI),yes)
	dh_auto_clean -Bbuild-openmpi
endif
ifneq ($(filter $(DEB_HOST_ARCH),$(OMPT_ARCHS)),)
	dh_auto_clean -Bbuild-ompt
endif

override_dh_auto_install:
	dh_auto_install -Bbuild-mpich
ifeq ($(OPENMPI),yes)
	dh_auto_install -Bbuild-openmpi -- -C src/modules/mpi
endif
ifneq ($(filter $(DEB_HOST_ARCH),$(OMPT_ARCHS)),)
	dh_auto_install -Bbuild-ompt -- -C src/modules/ompt
endif

# Some MPI drivers assume we won't fork, but we will, so tell them to be safe.
export RDMAV_FORK_SAFE=1

override_dh_auto_test:
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?.*src/modules/omp/bin/eztrace_cc\ .*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?\[eztrace_cc\].*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc\ -o\ test_task.*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc\ -o\ starpu_.*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc\ -o\ .*\ -pthread'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc.*\ memory.c.*\ -o\ memory'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc\ -o\ foo\ foo.c.*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?g\+\+\ -o\ vector\ vector.cxx'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?.*/cc\ .*\ -c\ .*/test/.*.c'
	# This is an mpich smoke test. If this fails, please report to mpich, not eztrace
	mpirun.mpich -np 2 --bind-to none ./build-mpich/test/mpi/mpi_ping | grep "10000	16" || touch $(FAILED)
ifeq ($(OPENMPI),yes)
	# This is an openmpi smoke test. If this fails, please report to openmpi, not eztrace
	mpirun.openmpi -np 2 --map-by :OVERSUBSCRIBE --bind-to none ./build-openmpi/test/mpi/mpi_ping | grep "10000	16" || touch $(FAILED)
endif
	! test -f $(FAILED) || (rm $(FAILED) ; false)
	verbose=1 STARPU_HOME=$(CURDIR) MPICC_PATH=mpicc.mpich MPIRUN_PATH=mpirun.mpich MPI_MODULE_NAME=mpich dh_auto_test --no-parallel -Bbuild-mpich -- -k ARGS\+=--extra-verbose || touch $(FAILED)
	-rm -fr .starpu
ifeq ($(OPENMPI),yes)
	verbose=1 MPIRUN_CLI_OPTION=--oversubscribe MPICC_PATH=mpicc.openmpi MPIRUN_PATH=mpirun.openmpi MPI_MODULE_NAME=openmpi dh_auto_test --no-parallel -Bbuild-openmpi -- -k ARGS\+=--extra-verbose || touch $(FAILED)
endif
ifneq ($(filter $(DEB_HOST_ARCH),$(OMPT_ARCHS)),)
	verbose=1 dh_auto_test --no-parallel -Bbuild-ompt -- -k ARGS\+=--extra-verbose || touch $(FAILED)
endif
	! test -f $(FAILED) || (rm $(FAILED) ; false)

override_dh_dwz:
	:

=== debian/tests/control ===
Depends: build-essential, eztrace, otf2-tools
Test-Command: cd test/compiler_instrumentation ; make clean ; verbose=1 ./run.sh
Restrictions: allow-stderr

Depends: build-essential, eztrace, otf2-tools, gawk
Test-Command: cd test/memory ; make clean ; verbose=1 ./run.sh
Restrictions: allow-stderr

Depends: build-essential, mpich, libmpich-dev, gawk
Test-Command: cd test/mpi ; make clean ; MPICC_PATH=mpicc.mpich make mpi_ping ; mpirun.mpich -np 2 ./mpi_ping | grep "10000	16"
Restrictions: allow-stderr

Depends: build-essential, eztrace, otf2-tools, mpich, libmpich-dev, gawk
Test-Command: cd test/mpi ; make clean ; MPICC_PATH=mpicc.mpich MPIRUN_PATH=mpirun.mpich MPI_MODULE_NAME=mpich verbose=1 ./run.sh
Restrictions: allow-stderr

Depends: build-essential, openmpi-bin, libopenmpi-dev, gawk
Test-Command: cd test/mpi ; make clean ; MPICC_PATH=mpicc.openmpi make mpi_ping ; mpirun.openmpi --oversubscribe -np 2 ./mpi_ping | grep "10000	16"
Restrictions: skip-not-installable, allow-stderr

Depends: build-essential, eztrace, otf2-tools, openmpi-bin, libopenmpi-dev, gawk
Test-Command: cd test/mpi ; make clean ; MPIRUN_CLI_OPTION=--oversubscribe MPICC_PATH=mpicc.openmpi MPIRUN_PATH=mpirun.openmpi MPI_MODULE_NAME=openmpi verbose=1 ./run.sh
Restrictions: skip-not-installable, allow-stderr

Depends: build-essential, eztrace, otf2-tools, clang, libomp-dev, gawk
Test-Command: cd test/ompt ; make clean ; verbose=1 CC=clang ./run.sh
Architecture: amd64 arm64 ppc64el riscv64 loong64
Restrictions: allow-stderr

Depends: build-essential, eztrace, otf2-tools, libpomp2-dev, bc, gawk
Test-Command: cd test/openmp ; make clean ; verbose=1 ./run.sh
Restrictions: allow-stderr

Depends: build-essential, eztrace, otf2-tools, bc
Test-Command: cd test/posixio ; make clean ; verbose=1 ./run.sh
Restrictions: allow-stderr

Depends: build-essential, eztrace, otf2-tools
Test-Command: cd test/pthread ; make clean ; verbose=1 ./run.sh
Restrictions: allow-stderr

Depends: build-essential, eztrace, otf2-tools, pkg-config, libstarpu-dev, gawk
Test-Command: cd test/starpu ; make clean ; verbose=1 ./run.sh
Restrictions: allow-stderr
